<template>
  <div :class="['ob-alert-container', `ob-alert-theme-${theme}`]">
    <i
      v-if="icon"
      :class="[
        'icon ob-alert__icon',
        themeIcon ? `ob-alert-theme-${themeIcon}` : '',
        icon
      ]"
    />

    <div class="ob-alert__text">
      <span
        v-if="text"
        v-html="text"
      />

      <slot v-else />
    </div>

    <button
      v-if="!hideCloseButton"
      type="button"
      class="ob-alert__close"
      :data-qa="dataQa"
      @click="closeAlert"
    >
      <i class="icon close" />
    </button>
  </div>
</template>

<script>
export default {
  name: 'ObAlert',
  props: {
    text: {
      type: String,
      default: null
    },
    icon: {
      type: String,
      default: null
    },
    theme: {
      type: String,
      default: 'info'
    },
    themeIcon: {
      type: String,
      default: null
    },
    hideCloseButton: {
      type: Boolean,
      default: false
    },
    timeout: {
      type: Number,
      default: null
    },
    dataQa: {
      type: String
    }
  },
  mounted () {
    if (this.timeout) {
      setTimeout(() => {
        this.closeAlert()
      }, this.timeout)
    }
  },
  methods: {
    closeAlert () {
      this.$el.parentNode.removeChild(this.$el)

      this.$emit('close')
    }
  }
}
</script>

<style lang="scss" scoped>
  @import '../../assets/style/ob-style';

  @mixin flat-theme {
    --border-width: 0;

    box-shadow: none;
  }

  @function toRGB ($color) {
    @return red($color) + ', ' + green($color) + ', ' + blue($color);
  }

  $alert-spacing: 20px;

  .ob-alert-container {
    --border-width: 6px;
    --background-color: #{toRGB($background-white)};
    --background-color-opacity: 1;

    border-left: var(--border-width) solid var(--border-color);
    background-color: rgba(var(--background-color), var(--background-color-opacity));
    padding: $alert-spacing $alert-spacing $alert-spacing 0;
    display: flex;
    align-items: center;
    margin-bottom: 20px;
    position: relative;
    box-shadow: 0 4px 20px rgba($color-text-base, .2);
  }

  .ob-alert {
    &__icon {
      margin-left: $alert-spacing - 2px;
      font-size: 24px;
      color: var(--icon-color);
      align-self: flex-start;
    }

    &__text {
      @include font-mixin(14px, 18px, 400, $color-text-base);

      margin-left: $alert-spacing;

      &:not(:last-child) {
        margin-right: $alert-spacing;
      }
    }

    &__close {
      background: none;
      border: none;
      margin-left: auto;
      align-self: flex-start;
      font-size: 16px;
      color: $color-grey-border;
      cursor: pointer;
      display: flex; // To remove whitespace

      &:hover,
      &:focus {
        color: $shale-gray;
      }
    }
  }

  .ob-alert-theme {
    &-info {
      --border-color: #{$cobalt};
      --icon-color: #{$cobalt};
    }

    &-info-flat {
      @include flat-theme;

      --icon-color: #{$cobalt};
      --background-color: #{toRGB($color-white-lilac)};
    }

    &-success {
      --border-color: #{$color-green-light};
      --icon-color: #{$deep-blue};
    }

    &-success-flat {
      @include flat-theme;

      --icon-color: #{$deep-blue};
      --background-color: #{toRGB($Green-500)};
      --background-color-opacity: .1;
    }

    &-warning {
      --border-color: #{$diamond-orange-yellow};
      --icon-color: #{$diamond-orange-yellow};
    }

    &-danger {
      --border-color: #{$light-raspberry-red};
      --icon-color: #{$light-raspberry-red};
    }

    &-danger-flat {
      @include flat-theme;

      --icon-color: #{$light-raspberry-red};
      --background-color: #{toRGB($color-error)};
      --background-color-opacity: .1;
    }
  }
</style>
